VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Œ()
   ClientHeight    =   3090
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "MS UI Gothic"
      Size            =   9.75
      Charset         =   128
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows ̊l
   Begin MSComctlLib.ProgressBar prgBar 
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   2700
      Width           =   4635
      _ExtentX        =   8176
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.Frame fraDrag 
      Caption         =   "Excelt@ChbOĂ"
      Height          =   2475
      Left            =   120
      OLEDropMode     =   1  '蓮
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SHCreateDirectoryEx Lib "SHELL32.DLL" Alias "SHCreateDirectoryExA" ( _
    ByVal hWnd As Long, _
    ByVal pszPath As String, _
    ByVal psa As Long _
) As Long

Private mblnFstAcv As Boolean

Private mobjFso As Object
Private mobjXlsApp As Object

Private Sub Form_Load()
    mblnFstAcv = True
End Sub

Private Sub Form_Activate()
    If mblnFstAcv Then
        If Initialize = False Then
            Unload Me
        End If
        mblnFstAcv = False
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Call Finalize
End Sub

Private Function Initialize() As Boolean
    Initialize = False

    Me.Caption = App.Title & _
        " Ver. " & CStr(App.Major) & "." & CStr(App.Minor) & "." & CStr(App.Revision)

    Set mobjFso = CreateObject("Scripting.FileSystemObject")

    On Error Resume Next

    Set mobjXlsApp = CreateObject("Excel.Application")
    If Err.Number <> 0 Then
        MsgBox "ExcelCXg[Ă܂B", vbCritical + vbOKOnly, App.Title
        Exit Function
    End If

    On Error GoTo 0

    mobjXlsApp.Visible = False
    mobjXlsApp.DisplayAlerts = False

    Initialize = True
End Function

Private Sub Finalize()
    mobjXlsApp.Quit
    Set mobjXlsApp = Nothing

    Set mobjFso = Nothing
End Sub

Private Sub fraDrag_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call Execute(Data)
End Sub

Private Sub Execute(ByVal Data As DataObject)
    On Error GoTo Exception

    prgBar.Max = Data.Files.Count

    Dim i As Long
    For i = 1 To Data.Files.Count
        prgBar.Value = i

        Dim strXlsPath As String
        strXlsPath = Data.Files.Item(i)

        Dim strCsvBase As String
        strCsvBase = GetCsvFileBase(strXlsPath)

        If ExcelToCsv(strXlsPath, strCsvBase) = False Then
            prgBar.Value = 0
            Exit Sub
        End If
    Next i

    prgBar.Value = 0

    On Error GoTo 0

    Exit Sub

Exception:
    Call MsgBox(CStr(Err.Number) & ":" & Err.Description, vbOKOnly + vbCritical, App.Title)
    Err.Clear
    prgBar.Value = 0
End Sub

Private Function GetCsvFileBase(ByVal vstrXlsPath As String) As String
    Dim strCsvBase As String
    strCsvBase = GetCsvBaseName(vstrXlsPath)

    Dim strCsvFolder As String
    strCsvFolder = GetCsvFolder(vstrXlsPath)

    If mobjFso.FolderExists(strCsvFolder) = False Then
        Call MakeCsvFolder(strCsvFolder)
    End If

    GetCsvFileBase = strCsvFolder & "\" & strCsvBase
End Function

Private Function GetCsvBaseName(ByVal vstrXlsPath As String) As String
    GetCsvBaseName = mobjFso.GetBaseName(vstrXlsPath)
End Function

Private Function GetCsvFolder(ByVal vstrXlsPath As String) As String
    Dim strReturn As String
    strReturn = mobjFso.GetParentFolderName(vstrXlsPath)

    GetCsvFolder = strReturn & "\_csvfiles"
End Function

Private Sub MakeCsvFolder(ByVal vstrCsvFolder As String)
    Call SHCreateDirectoryEx(Me.hWnd, vstrCsvFolder, 0&)
End Sub

Private Function ExcelToCsv(ByVal vstrXlsPath As String, ByVal vstrCsvBase As String) As Boolean
    ExcelToCsv = False

    Dim objXlsBook As Object
    If CreateExcelObjects(vstrXlsPath, objXlsBook) = False Then
        Exit Function
    End If

    Dim objXlsSheet As Object
    For Each objXlsSheet In objXlsBook.Worksheets
        objXlsSheet.Activate
        Call objXlsBook.SaveAs(vstrCsvBase & "_" & objXlsSheet.Name & ".csv", 6, , , , , , , , , , True)
    Next objXlsSheet

    Call DisposeExcelObjects(objXlsBook)

    ExcelToCsv = True
End Function

Private Function CreateExcelObjects( _
    ByVal vstrXlsPath As String, _
    ByRef robjXlsBook As Object _
) As Boolean
    CreateExcelObjects = False

    On Error Resume Next

    Set robjXlsBook = mobjXlsApp.Workbooks.Open(vstrXlsPath, 3, True)

    If Err.Number <> 0 Then
        MsgBox CStr(Err.Number) & ":" & Err.Description, vbCritical + vbOKOnly, App.Title
        Exit Function
    End If

    On Error GoTo 0

    CreateExcelObjects = True
End Function

Private Sub DisposeExcelObjects(ByRef robjXlBook As Object)
    robjXlBook.Close
    Set robjXlBook = Nothing
End Sub
